#!/bin/sh
# http://www.celt-codec.org/
#
# Celt low-latency audio codec.
# needed for low latency netjack transmission via internet.
#
# script by: til <rob DOT til DOT freedman AT googlemail DOT com>
REPO=http://zenwalk.pinguix.com/user-accounts/tilderb
set -e -u -x

# celt
version=0.9.1
build=66.1

arch=${arch:-i486}
#tune=pentium-m
tune=${tune:-i686}

PKG_DEP="libogg"
PKG_SRC="$REPO/extra/ap/celt/build-celt.sh
http://downloads.us.xiph.org/releases/celt/celt-$version.tar.gz"

# call from empty/new dir to force download
for url in $PKG_SRC;do [ ! -e ${url##*/} ] && wget -N $url; done
#
CWD=`pwd`
TMP=${tmp:-$CWD/tmp}
#
pkgname=celt-$version
package=$pkgname-$arch-$build

PKG=$TMP/$package;
SRC=$TMP/$pkgname;

# clean start
[ -d $PKG ] && rm -fr $PKG;
[ -d $SRC ] && rm -fr $SRC;

# build dir
mkdir -p $SRC $PKG/{install,usr/{src,doc}/$pkgname}

# unpack source
tar xf $CWD/$pkgname.tar.gz -C $TMP
cd $SRC
# helperline
./configure --help >$CWD/configure-help

#patch -p1 -i $CWD/pitch-downsample.patch

CFLAGS="-O2 -march=$arch -mtune=$tune"  \
 ./configure --prefix=/usr --enable-experimental-postfilter  #--enable-new-plc 

make || exit 1
#make check
make install DESTDIR=$PKG

# helperline
(cd $PKG;find usr -printf "%M %u:%g %p %l\n" >$CWD/make.installed)

cp -a COPYING README TODO $PKG/usr/doc/$pkgname

cd $PKG
# strip symbols
find . | xargs file | grep "executable\|shared object" | grep ELF |\
	cut -f 1 -d : | xargs -r strip --strip-unneeded
	
find . | xargs file | grep "current ar archive" |\
	cut -f 1 -d : | xargs -r strip -g

# copy build script
cp $CWD/build-celt.sh $CWD/pitch-downsample.patch \
	usr/src/$pkgname

# slack description
#    |-----handy-ruler------------------------------------------------------|
cat <<EOF > install/slack-desc
celt: celt (The CELT ultra-low delay audio codec)
celt:
celt: The CELT codec is an experimental audio codec for use in low-delay
celt: speech and audio communication.
celt:
celt: CELT stands for "Constrained Energy Lapped Transform".
celt: It applies some of the CELP principles, but does everything in the
celt: frequency domain, which removes some of the limitations of CELP.
celt:
celt: CELT is suitable for both speech and music
EOF

fakeroot /sbin/makepkg -l y -c n $CWD/$package.txz

cd $CWD
echo "$PKG_SRC" >$package.src
echo -n $PKG_DEP >$package.dep
depfinder $PKG
md5sum $package.txz >$package.md5

#rm -fr $SRC $PKG
exit



patch -p2 -l <<"EOF"
--- git/celt/libcelt/celt.c    Wed Jan 27 17:38:11 2010
+++ tmp/celt/libcelt/celt.c    Wed Jan 27 10:55:39 2010
@@ -1040,6 +1040,16 @@ int celt_encoder_ctl(CELTEncoder * restr
         CELT_MEMSET(st->preemph_memE, 0, C);
         CELT_MEMSET(st->preemph_memD, 0, C);
         st->delayedIntra = 1;
+
+         st->fold_decision = 1;
+         st->tonal_average = QCONST16(1.,8);
+         st->gain_prod = 0;
+         st->vbr_reservoir = 0;
+         st->vbr_drift = 0;
+         st->vbr_offset = 0;
+         st->vbr_count = 0;
+         st->xmem = 0;
+         CELT_MEMSET(st->pitch_buf, 0, (MAX_PERIOD>>1)+2);
      }
      break;
      default:
@@ -1629,6 +1639,10 @@ int celt_decoder_ctl(CELTDecoder * restr
         CELT_MEMSET(st->preemph_memD, 0, C);

         st->loss_count = 0;
+
+#ifdef NEW_PLC
+         CELT_MEMSET(st->lpc, 0, C*LPC_ORDER);
+#endif
      }
      break;
      default:
EOF
